/*
 * ѥȤʤʸϤɤǡʸĹĴ
 * ǲϤη̤Ϥ
 *
 * ϷˤĤ
 *  ޤ̤Ԥäʸ᤬ǽĹǽϤ
 *  ˳ʸ()ä䡢νǾϤ
 *
 *
 * Copyright (C) 2006-2007 TABATA Yusuke
 *
 */
#if 0		/* Patched by G-HAL */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <anthy/convdb.h>
#else
#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_MALLOC_H)
# include <malloc.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_STRINGS_H)
# include <strings.h>
#endif

#include "anthy/settings.h"	/* Patched by G-HAL, Tue,10 Nov,2009 */
#include "anthy/anthy.h"	/* Patched by G-HAL, Tue,10 Nov,2009 */
#include "src-main/main.h"	/* Patched by G-HAL, Tue,10 Nov,2009 */
#include "anthy/splitter.h"	/* Patched by G-HAL, Tue,10 Nov,2009 */
#include "anthy/segment.h"	/* Patched by G-HAL, Tue,10 Nov,2009 */
#include "anthy/convdb.h"
#endif

static int verbose;

/* ʸĹʸˤ碌 */
#if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
static int
trim_segment(anthy_context_t ac, struct conv_res *cr,
	     int nth, char *seg)
#else
static int trim_segment( anthy_context_t ac, _unused struct conv_res* const cr, int nth, char* seg, char* wt )
#endif
{
  int len = strlen(seg);
  int resized = 0;
 #if 0	/* Patched by G-HAL, Sun,16 Dec,2012 */
 #else
  if (len < 1) {
    return 0;
  }
 #endif

 #if 0	/* Patched by G-HAL, Sun,16 Dec,2012 */
 #else
  int cur_len_old = 0;
 #endif
  while (1) {
    char seg_buf[1024];
    int cur_len;

    anthy_get_segment(ac, nth, NTH_UNCONVERTED_CANDIDATE, seg_buf, 1024);
    cur_len = strlen(seg_buf);
   #if 0	/* Patched by G-HAL, Sun,16 Dec,2012 */
   #else
    if (cur_len_old == cur_len) {
      return 0;
    }
    cur_len_old = cur_len;
   #endif
    if (len == cur_len) {
      return 1;
    }
    if (!resized) {
      resized = 1;
      /* ʸξɽ */
      print_size_miss_segment_info(ac, nth);
    }
    if (len > cur_len) {
      anthy_resize_segment(ac, nth, 1);
    } else {
      anthy_resize_segment(ac, nth, -1);
    }
  }
  return 0;
}

#if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
/*
 * nthܤʸǸsegõƳꤹ
 */
static int
find_candidate(anthy_context_t ac, struct conv_res *cr,
	       int nth, char *seg)
{
  char seg_buf[1024];
  int i;
  struct anthy_segment_stat ass;

  if (seg[0] == '~') {
    /* ߥΥޡ~פ򥹥åפ */
    seg++;
    cr->cand_check[nth] = 1;
  }

  anthy_get_segment_stat(ac, nth, &ass);
  for (i = 0; i < ass.nr_candidate; i++) {
    anthy_get_segment(ac, nth, i, seg_buf, 1024);
    if (!strcmp(seg_buf, seg)) {
      /* פ򸫤ĤΤǳꤹ */
      anthy_commit_segment(ac, nth, i);
      return 0;
    }
  }
  return 0;
}

/* '|' ʸ˶ڤ줿ʸγʸfnƤ */
static int
for_each_segment(anthy_context_t ac, struct conv_res *cr,
		 const char *res_str,
		 int (*fn)(anthy_context_t ac, struct conv_res *cr,
			   int nth, char *seg))
{
  char *str, *cur, *cur_seg;
  int nth;
  if (!res_str) {
    return 0;
  }

  str = strdup(res_str);
  cur = str;
  cur ++;
  cur_seg = cur;
  nth = 0;
  while ((cur = strchr(cur, '|'))) {
    *cur = 0;
    /**/
    if (fn) {
      fn(ac, cr, nth, cur_seg);
    }
    /**/
    nth ++;
    cur ++;
    cur_seg = cur;
  }

  free(str);

  return 1;
}
#else
/** ꤵ줿ʸˤơꤵ줿ꤹ롣
 *@param[in]		ac			Ѵ䷲
 *@param[in]		cr			Ѵ̤ʸ
 *@param		nth			Ԥʸֹ
 *@param[in]		seg			Ѵ̡NULLԲġ
 *@param[in]		wt			ʻNULLġ
 *@retval		0			
 *@retval		1			
 *
 *	Patched by G-HAL
 *		Tue,10 Nov,2009
 *@date		Tue,06 Nov,2012
 */
static int find_candidate( anthy_context_t ac, struct conv_res* const cr, int nth, char* seg, char* wt )
{
  struct anthy_segment_stat ass;
  const struct seg_ent* const se = anthy_get_nth_segment( &(ac->seg_list), nth );
  int i;
  char seg_buf[1024];

  if (NULL == se) {
    return 0;
  }

  if ('~' == seg[0]) {
    /* ߥΥޡ~פ򥹥åפ */
    ++ seg;
    cr->cand_check[nth] = 1;
  }

  anthy_get_segment_stat( ac, nth, &ass );
  for (i = 0; i < ass.nr_candidate; ++i) {
    const struct cand_ent* const ce = se->cands[i];
    anthy_get_segment( ac, nth, i, seg_buf, sizeof(seg_buf) );
    if (0 == strcmp(seg_buf, seg)) {
      if (wt && wt[0]) {
	if (NULL == ce->mw) {
	  continue;
	}
	if (0 != strcmp(wt,anthy_seg_class_sym(ce->mw->seg_class))) {
	  continue;
	}
      }
      /* פ򸫤ĤΤǳꤹ */
      anthy_commit_segment( ac, nth, i );
      return 1;
    }
  }
  return 0;
}

/** ʸڤ국˶ڤäƥִؿƤӽФ
 *@param[in]		ac			Ѵ䷲
 *@param[in]		cr			Ѵ̤ʸ
 *@param[in]		res_str			Ѵ̤ʸڤ국դʸNULLԲġ
 *@param[in]		wt_str			ʻʸڤ국դʸNULLġ
 *@param[in]		fn			ִؿ
 *@retval		0			
 *@retval		1			
 *
 *@comment
 *	ʸڤ국 '|'
 *
 *	Patched by G-HAL
 *		Tue,10 Nov,2009
 */
static int for_each_segment( anthy_context_t ac, struct conv_res* const cr,
			    const char* const res_str, const char* const wt_str,
			    int (* const fn)( anthy_context_t ac, struct conv_res* const cr, int nth, char* seg, char* wt ) )
{
  static const char	PHRASE_SEPARATOR = '|';
  char* const	res        = res_str ? strdup(res_str) : NULL;
  char*		res_ptr    = res;
  char*		curseg_res = res_ptr;
  char* const	wt        = wt_str ? strdup(wt_str) : NULL;
  char*		wt_ptr    = wt;
  char*		curseg_wt = wt_ptr;
  int		nth;
  int		ret = 0;

  if (NULL == res_ptr) {
    if (wt) {
      free( wt );
    }
    return 0;
  }

  nth = 0;
  curseg_res = ++ res_ptr;
  curseg_wt  = wt ? (++ wt_ptr) : NULL;
  while ((res_ptr = strchr(curseg_res, PHRASE_SEPARATOR))) {
    *res_ptr = '\0';

    if (curseg_wt) {
      wt_ptr = strchr( curseg_wt, PHRASE_SEPARATOR );
      if (wt_ptr) {
	*wt_ptr = '\0';
      }
    }

    if (fn) {
      ret = fn( ac, cr, nth, curseg_res, curseg_wt );
    }

    ++ nth;
    curseg_res = ++ res_ptr;
    curseg_wt  = curseg_wt ? (++ wt_ptr) : NULL;
  }

  if (wt) {
    free( wt );
  }
  free( res );
  return ret;
}
#endif

#if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
static void
proc_sentence(anthy_context_t ac, struct conv_res *cr)
#else
static int proc_sentence( anthy_context_t ac, struct conv_res* const cr )
#endif
{
 #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
 #else
  int ret = 1;
 #endif
  int i;
  struct anthy_conv_stat acs;
  /*printf("(%s)\n", cr->src_str);*/
  anthy_set_string(ac, cr->src_str);
  /* ʸĹĴ᤹ */
 #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
  if (!for_each_segment(ac, cr, cr->res_str, trim_segment)) {
    return ;
  }
 #else
  if (0 == for_each_segment(ac, cr, cr->res_str, cr->wt_str, trim_segment)) {
    return 0;
  }
 #endif
  /**/
  if (anthy_get_stat(ac, &acs)) {
   #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
    return ;
   #else
    return 0;
   #endif
  }
  cr->cand_check = (int*) malloc(sizeof(int) * acs.nr_segment);
  for (i = 0; i < acs.nr_segment; i++) {
    cr->cand_check[i] = 0;
  }

  /* 򤹤 */
  if (cr->cand_str) {
   #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
    for_each_segment(ac, cr, cr->cand_str, find_candidate);
   #else
    if (0 == for_each_segment( ac, cr, cr->cand_str, cr->wt_str, find_candidate )) {
      ret = 0;
    }
   #endif
  }

  if (verbose) {
    anthy_print_context(ac);
  }
  /* Ϥ */
  print_context_info(ac, cr);
 #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
 #else
  return ret;
 #endif
}

int
main(int argc, char **argv)
{
  struct res_db *db;
  struct conv_res *cr;
  anthy_context_t ac;
  int i;

  db = create_db();
  for (i = 1; i < argc; i++) {
    if (!strcmp("-v", argv[i])) {
      verbose = 1;
    } else {
      read_db(db, argv[i]);
    }
  }

  anthy_settings.anthy_mode.anonymous  = 1;		/* Patched by G-HAL, Tue,10 Nov,2009 */
  anthy_settings.anthy_mode.proccorpus = 1;		/* Patched by G-HAL, Tue,10 Nov,2009 */
  anthy_conf_override("CONFFILE", "../anthy-conf");
  anthy_conf_override("DIC_FILE", "../mkanthydic/anthy.dic");
  anthy_init();
  anthy_set_personality("");
  ac = anthy_create_context();

  /**/
  for (cr = db->res_list.next; cr; cr = cr->next) {
   #if 0	/* Patched by G-HAL, Tue,10 Nov,2009 */
    proc_sentence(ac, cr);
   #else
    if (0 == proc_sentence( ac, cr )) {
      fprintf(stderr, "Can not converted: '%s','%s','%s'\n",
	      cr->res_str,
	      cr->cand_str,
	      cr->wt_str ? cr->wt_str : ""
	      );
    }
   #endif
  }

  anthy_quit();		/* Patched by G-HAL, Sun,25 Sep,2011 */
  return 0;
}
/* vim:ts=8 sw=2 nomodified:
 */
